﻿$dir = "e:\"
$exe = "C:\refsc\blockstat.exe"

$listfilepath = "c:\refsc\in.txt"
$outputpath = "c:\refsc\out.xml"




function blockstatwrapper {
    param($exe,$listfilepath,$outputpath)
    $x = Start-Process -FilePath $exe -ArgumentList @("-x","-i",$listfilepath,"-o",$outputpath) -Wait -PassThru
    $result = [xml](Get-Content $outputpath)


    $fod = 0
    $result.result.shares.ChildNodes | % { $sl=$_;write-host ("{0}x {1} ({2}mb)" -f $sl.ratio,$sl.bytes,$sl.mb);$fod+=([Int64]::Parse($sl.ratio)*[Int64]::Parse($sl.bytes))}
    write-host ("")
    write-host ("Total File On Disk {0}" -f $fod)
    write-host ("Total Savings {0}" -f $result.result.totalshare.bytes)
    write-host ("Total Fragments {0}" -f $result.result.fragments.count)
    
}

#method one, list files, should be the easiest
function method1 {
    param($exe,$listfilepath,$outputpath)
    

    #$files = Get-ChildItem -Path $dir -Recurse -Depth 10 -file -Include "*.vbk","*.vib","*.vrb" | % { $_.FullName } 
    $filesgroup = Get-ChildItem -Path $dir -Recurse -Depth 10 -file -Include "*.vbk","*.vib","*.vrb" | Group-Object -Property directory
    foreach ($gr in $filesgroup) {
        write-host $gr.Name
        $files = $gr.group | % { $_.FullName }
        $files | Set-Content -Path $listfilepath -Encoding Unicode
        blockstatwrapper -exe $exe -listfilepath $listfilepath -outputpath $outputpath
        write-host "";write-host ""
    }
    
}

method1 -exe $exe -listfilepath $listfilepath -outputpath $outputpath





#method 2, get files based on backup server data. 100% breakages on scaleout repo
function method2 {
    param($exe,$listfilepath,$outputpath,$backupserver)


    $session = New-PSSession $backupserver
    $filesgroup = Invoke-Command -Session $session -ScriptBlock {
        param($a)
        asnp veeampssnapin

        $gr = @{}
        Get-VBRBackup | % {
            $backup = $_
            $files = $backup.GetAllStorages() | % { $s = $_;$s.FilePath.ToString() }
            $gr[$backup.Name] = New-Object -TypeName psobject -Property @{Name=$backup.Name;Files=$files}
        }
        return $gr
    }  -ArgumentList @{jobname=$backupjob}
    $session | Remove-PSSession

    foreach($key in $filesgroup.Keys) {
        write-host $key
        $files = $filesgroup[$key].Files
        $files | Set-Content -Path $listfilepath -Encoding Unicode
        blockstatwrapper -exe $exe -listfilepath $listfilepath -outputpath $outputpath
        write-host "";write-host "" 
    }
}

#method2 -exe $exe -listfilepath $listfilepath -outputpath $outputpath -backupserver "localhost"

